Subject: Re: [e1000 debug] KERNEL: assertion (!sk_forward_alloc) failed...

From: "David S. Miller" <[email-masked]>
Date: Fri, 31 Mar 2006 01:13:24 -0800 (PST)

From: Herbert Xu <[email-masked]>
Date: Thu, 30 Mar 2006 20:52:45 +1100

> Well I started from the beginning again, and found this.  This may be
> the smoking gun that we're after :)
> 
> The xmit routine is lockless but checks last_tx_tso outside the locked
> section.  So if a TSO packet wins a race against a non-TSO packet with
> last_tx_tso == 0 then we'll have memory corruption.

Regardless of whether this fixes the bug being discussed, this
fix should go into the e1000 driver ASAP.

Good spotting Herbert.

-------------------------------------------------------
This SF.Net email is sponsored by xPML, a groundbreaking scripting language
that extends applications into web and mobile media. Attend the live webcast
and join the prime developer group breaking into this new coding territory!
http://sel.as-us.falkag.net/sel?cmd=lnk&kid=110944&bid=241720&dat=121642